package Network;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.concurrent.LinkedBlockingQueue;
import java.net.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
public class ServerBlueJ extends JFrame{
    private ArrayList<ConnectionToClient> clientList;
    private LinkedBlockingQueue<UniqueObject> messages;
    private ServerSocket serverSocket;
    int limitConnections;
    JTextField ipField = new JTextField(10);
    JTextField numConnField = new JTextField(2);
    public ServerBlueJ(int limitConn) {
        int port =8995;
        limitConnections=limitConn;
        clientList = new ArrayList<ConnectionToClient>();
        messages = new LinkedBlockingQueue<UniqueObject>();
        try {
            serverSocket = new ServerSocket(port);
        } catch (IOException e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }

        Thread accept = new Thread() {
                public void run(){

                    while(clientList.size()<limitConnections){
                        try{
                            Socket s = serverSocket.accept();
                            System.out.println("Client"+    s.getRemoteSocketAddress());
                            clientList.add(new ConnectionToClient(s));
                            numConnField.setText(""+clientList.size());
                        }
                        catch(IOException e){ e.printStackTrace(); }
                    }
                }
            };
       
        accept.setDaemon(true);
        accept.start();
        
        Thread messageHandling = new Thread() {
                public void run(){
                    while(true){
                        try{
                            UniqueObject message = messages.remove();
                            // Do some handling here...
                            sendToAll(message);
                            System.out.println("Message Received: " + message);
                        }
                        catch(Exception e){ }
                    }
                }
            };

        messageHandling.setDaemon(true);
        messageHandling.start();

        Container screen = getContentPane();
        screen.setBackground(Color.white);
        screen.setLayout (new FlowLayout() );
        screen.add(new JLabel("IP"));
        ipField.setEditable(false);
        numConnField.setEditable(false);        
        screen.add(ipField);
        screen.add(new JLabel("Num of Connections:"));        
        screen.add(numConnField);
                String ip="";
                try {
            ip=IpChecker.getIp();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        ipField.setText(ip);
        setSize(200,100);
        setVisible(true);
        setTitle("Server");
        setClose(this);
    }

    public void stopServer(){
        System.out.println("closing socket");
        try {       
            for(ConnectionToClient client : clientList)
                client.socket.close();
            serverSocket.close();

        } catch (Exception e1) {
            // TODO Auto-generated catch block
            //e1.printStackTrace();
        }
    }

    public void setClose(JFrame j)
    {
        j.addWindowListener(new WindowAdapter()
            {
                public void windowClosing(WindowEvent e)
                {
                    try {                   
                        stopServer();
                        System.out.println("server stopped");
                    } catch (Exception e1) {
                        // TODO Auto-generated catch block
                        System.out.println("trouble stopping server");
                    }
                    System.exit(0);
                }
            });
    }

    private class ConnectionToClient {
        ObjectInputStream in;
        ObjectOutputStream out;
        Socket socket;

        ConnectionToClient(Socket s) throws IOException {
            this.socket = s;
            in = new ObjectInputStream(s.getInputStream());
            out = new ObjectOutputStream(s.getOutputStream());

            Thread read = new Thread(){
                    public void run(){
                        while(true){
                            try{
                                Object obj = in.readObject();
                                messages.add(new UniqueObject(obj,socket.getRemoteSocketAddress()));
                            }
                            catch(Exception e){// e.printStackTrace(); 
                            }
                        }
                    }
                };

            read.setDaemon(true); // terminate when main ends
            read.start();
        }

        public void closeConnection()
        {
            // socket.close();
        }

        public void write(Object obj) {
            try{
                out.writeObject(obj);
            }
            catch(IOException e){ e.printStackTrace(); }
        }
    }

    public void sendToAll(UniqueObject message){
        for(ConnectionToClient client : clientList)
        {
            if (!client.socket.getRemoteSocketAddress().equals(message.s))
                client.write(message.o);
            System.out.println("sending message out to everyone");
        }
    }

}

class UniqueObject
{
    Object o;
    SocketAddress s;
    public UniqueObject (Object o,SocketAddress s)
    {
        this.o=o;
        this.s=s;
    }
}

class Popup implements Runnable {
    public void run() {
        String ip="unknown";;
        try {
            ip=IpChecker.getIp();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        JOptionPane.showMessageDialog(null,"Your ip is:" + ip);

    }
}

class IpChecker {

    public static String getIp() throws Exception {
        URL whatismyip = new URL("http://checkip.amazonaws.com");
        BufferedReader in = null;
        try {
            in = new BufferedReader(new InputStreamReader(
                    whatismyip.openStream()));
            String ip = in.readLine();
            return ip;
        } finally {
            if (in != null) {
                try {
                    in.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}