

import java.net.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

public class Server implements Runnable, Connection{ 

	ServerSocket serverSocket;
	Socket socket;
	ObjectOutputStream oos;
	WatcherFrame watchedProgram;

	public Server (WatcherFrame watchedProgram,int width, int height, boolean showInfo)  {
		
		this.watchedProgram=watchedProgram;
		
		
		setClose(watchedProgram);
		
		watchedProgram.init();
		watchedProgram.setSize(width,height);
		watchedProgram.setVisible(true);
		watchedProgram.setConnection(this);
		if (showInfo)
			new Thread(new Popup()).start();
	

	} 


	public void stopServer(){
		System.out.println("closing socket");
		try {					
			socket.close();
			serverSocket.close();
			
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			//e1.printStackTrace();
		}
	}

	public void setClose(JFrame j)
	{
		j.addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				try {					
					stopServer();
					System.out.println("server stopped");
				} catch (Exception e1) {
					// TODO Auto-generated catch block
					System.out.println("trouble stopping server");
				}
				System.exit(0);
			}
		});
	}
	
	public void run ( )  {

		try  {
			int port=8999;
			
			serverSocket = new ServerSocket ( port);			
			socket = serverSocket.accept();
			oos = new ObjectOutputStream(socket.getOutputStream());
			System.out.println("server up and running ");
			processUpdate();
			
			
		}
		catch (Exception e) {
			System.out.println("server not running!!!");
		}
	}


	public void processUpdate(){
		try {
			ObjectInputStream ois = new ObjectInputStream(socket.getInputStream());
			Object b;
			while (true)
			{
				b=ois.readObject();
				watchedProgram.receiveUpdate(b);
			}

		} 
		catch (Exception e) {
			e.printStackTrace();
			System.out.println("trouble with connection or receiving the object");
		}
		


	} 

	public void sendObject(Object b) {
		// TODO Auto-generated method stub
		try {		
			System.out.println("sending object b");
		    oos.writeObject(b);
		    oos.reset();
		    //oos.flush();
		   // oos.close();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			System.out.println("problem with sending object");			
		}
	}

}



class Popup implements Runnable {
	   public void run() {
		   String ip="unknown";;
		   try {
			ip=IpChecker.getIp();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		   JOptionPane.showMessageDialog(null,"Your ip is:" + ip);
		   
	   }
	}

class IpChecker {

    public static String getIp() throws Exception {
        URL whatismyip = new URL("http://checkip.amazonaws.com");
        BufferedReader in = null;
        try {
            in = new BufferedReader(new InputStreamReader(
                    whatismyip.openStream()));
            String ip = in.readLine();
            return ip;
        } finally {
            if (in != null) {
                try {
                    in.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}